diff -urN ../sys/net/if_atm.h ./net/if_atm.h
--- ../sys/net/if_atm.h	Mon May 11 03:53:05 1998
+++ ./net/if_atm.h	Thu Jun 21 17:56:48 2001
@@ -42,6 +42,14 @@
 #endif
 #endif /* freebsd doesn't define _KERNEL */
 
+#ifndef NO_ATM_PVCEXT
+/*
+ * ATM_PVCEXT enables PVC extention: VP/VC shaping
+ * and PVC shadow interfaces.
+ */
+#define ATM_PVCEXT	/* enable pvc extention */
+#endif
+
 #if defined(__NetBSD__) || defined(__OpenBSD__) || defined(__bsdi__)
 #define RTALLOC1(A,B)		rtalloc1((A),(B))
 #elif defined(__FreeBSD__)
@@ -67,6 +75,9 @@
 #define ATM_PH_AAL5    0x01	/* use AAL5? (0 == aal0) */
 #define ATM_PH_LLCSNAP 0x02	/* use the LLC SNAP encoding (iff aal5) */
 
+#ifdef ATM_PVCEXT
+#define ATM_PH_INERNAL  0x20	/* reserve for kernel internal use */
+#endif
 #define ATM_PH_DRIVER7  0x40	/* reserve for driver's use */
 #define ATM_PH_DRIVER8  0x80	/* reserve for driver's use */
 
@@ -85,6 +96,36 @@
 #define SIOCATMENA	_IOWR('a', 123, struct atm_pseudoioctl) /* enable */
 #define SIOCATMDIS	_IOWR('a', 124, struct atm_pseudoioctl) /* disable */
 
+#ifdef ATM_PVCEXT
+
+/* structure to control PVC transmitter */
+struct pvctxreq {
+    /* first entry must be compatible with struct ifreq */
+    char pvc_ifname[IFNAMSIZ];		/* if name, e.g. "en0" */
+    struct atm_pseudohdr pvc_aph;	/* (flags) + vpi:vci */
+    struct atm_pseudohdr pvc_joint;	/* for vp shaping: another vc
+					   to share the shaper */
+    int pvc_pcr;			/* peak cell rate (shaper value) */
+};
+
+/* structure to control PVC bridging */
+struct pvcfwdreq {
+    /* first entry must be compatible with struct ifreq */
+    char pvc_ifname[IFNAMSIZ];		/* if name, e.g. "en0" */
+    char pvc_ifname2[IFNAMSIZ];		/* if name to be bridged to/from */
+    int	 pvc_op;			/* 1:add 0:delete */
+};
+
+/* use ifioctl for now */
+#define SIOCSPVCFWD	_IOW('i', 93, struct pvcfwdreq)
+#define SIOCGPVCFWD	_IOWR('i', 94, struct pvcfwdreq)
+#define SIOCSPVCTX	_IOWR('i', 95, struct pvctxreq)
+#define SIOCGPVCTX	_IOWR('i', 96, struct pvctxreq)
+#define SIOCSPVCSIF	_IOWR('i', 97, struct ifreq)
+#define SIOCGPVCSIF	_IOWR('i', 98, struct ifreq)
+
+#endif /* ATM_PVCEXT */
+
 /*
  * XXX forget all the garbage in if_llc.h and do it the easy way
  */
@@ -109,3 +150,28 @@
 int	atm_output __P((struct ifnet *, struct mbuf *, struct sockaddr *, 
 		struct rtentry *));
 #endif
+#ifdef ATM_PVCEXT
+#ifdef _KERNEL
+#include <sys/queue.h>
+/*
+ * ATM PVC subinterface: a trick to assign a subinterface
+ * to a PVC.
+ * with a pvc subinterface, each PVC looks like an individual
+ * Point-to-Point interface.
+ * as opposed to the NBMA model, a pvc subinterface is inherently
+ * multicast capable (no LANE/MARS required).
+ */
+struct pvcsif {
+	/*
+	 * The ifnet struct _must_ be at the head of this structure.
+	 */
+	struct ifnet sif_if;		/* ifnet structure per pvc */
+	struct atm_pseudohdr sif_aph;	/* flags + vpi:vci */
+	int	sif_vci;		/* vci no */
+	struct ifnet *sif_fwdifp;	/* bridging ifp */
+	LIST_ENTRY(pvcsif) sif_links;
+};
+struct ifnet *pvcsif_alloc __P((void));
+int pvc_set_fwd __P((char *, char *, int));
+#endif
+#endif /* ATM_PVCEXT */
diff -urN ../sys/net/if_atmsubr.c ./net/if_atmsubr.c
--- ../sys/net/if_atmsubr.c	Tue Sep 12 13:09:11 2000
+++ ./net/if_atmsubr.c	Thu Jun 21 17:56:48 2001
@@ -107,17 +107,29 @@
 	struct rtentry *rt0;
 {
 	u_int16_t etype = 0;			/* if using LLC/SNAP */
-	int s, error = 0, sz;
+	int s, error = 0, sz, len;
 	struct atm_pseudohdr atmdst, *ad;
 	register struct mbuf *m = m0;
 	register struct rtentry *rt;
 	struct atmllc *atmllc;
+	struct atmllc *llc_hdr = NULL;
 	u_int32_t atm_flags;
+#ifdef ALTQ
+	struct altq_pktattr pktattr;
+#endif
 
 	if ((ifp->if_flags & (IFF_UP|IFF_RUNNING)) != (IFF_UP|IFF_RUNNING))
 		senderr(ENETDOWN);
 	ifp->if_lastchange = time;
 
+#ifdef ALTQ
+	/*
+	 * if the queueing discipline needs packet classification,
+	 * do it before prepending link headers.
+	 */
+	IFQ_CLASSIFY(&ifp->if_snd, m,
+		     (dst != NULL ? dst->sa_family : AF_UNSPEC), &pktattr);
+#endif
 	/*
 	 * check route
 	 */
@@ -201,6 +213,15 @@
 			type = htons(ETHERTYPE_IPV6);
 			break;
 #endif /* INET6 */
+		case AF_UNSPEC:
+			/*
+			 * XXX: bpfwrite or output from a pvc shadow if.
+			 * assuming dst contains 12 bytes (atm pseudo
+			 * header (4) + LLC/SNAP (8))
+			 */
+			bcopy(dst->sa_data, &atmdst, sizeof(atmdst));
+			llc_hdr = (struct atmllc *)(dst->sa_data + sizeof(atmdst));
+			break;
 
 		default:
 #if defined(__NetBSD__) || defined(__OpenBSD__)
@@ -236,15 +257,18 @@
 	 * Queue message on interface, and start output if interface
 	 * not yet active.
 	 */
-
+	len = m->m_pkthdr.len;
 	s = splimp();
-	if (IF_QFULL(&ifp->if_snd)) {
-		IF_DROP(&ifp->if_snd);
+#ifdef ALTQ
+	IFQ_ENQUEUE(&ifp->if_snd, m, &pktattr, error);
+#else
+	IFQ_ENQUEUE(&ifp->if_snd, m, error);
+#endif
+	if (error) {
 		splx(s);
-		senderr(ENOBUFS);
+		return (error);
 	}
-	ifp->if_obytes += m->m_pkthdr.len;
-	IF_ENQUEUE(&ifp->if_snd, m);
+	ifp->if_obytes += len;
 	if ((ifp->if_flags & IFF_OACTIVE) == 0)
 		(*ifp->if_start)(ifp);
 	splx(s);
@@ -316,6 +340,33 @@
 	    m_adj(m, sizeof(*alc));
 	  }
 
+#ifdef ATM_PVCEXT
+	/* atm bridging support */
+	if ((ifp->if_flags & (IFF_POINTOPOINT|IFF_LINK2)) ==
+		(IFF_POINTOPOINT|IFF_LINK2)) {
+		struct pvcsif *pvcsif = (struct pvcsif *)ifp;
+
+		if (pvcsif->sif_fwdifp != NULL) {
+			struct sockaddr dst;
+
+			/* set address family to dummy dst addr */
+			switch (etype) {
+			case ETHERTYPE_IP:
+				dst.sa_family = AF_INET;
+				break;
+			case ETHERTYPE_IPV6:
+				dst.sa_family = AF_INET6;
+				break;
+			default:
+				m_freem(m);
+				return;
+			}
+			atm_output(pvcsif->sif_fwdifp, m, &dst, NULL);
+			return;
+		}
+	}
+#endif /* ATM_PVCEXT */
+
 	  switch (etype) {
 #ifdef INET
 	  case ETHERTYPE_IP:
@@ -376,4 +427,88 @@
 #endif
 			break;
 		}
+
+}
+
+#ifdef ATM_PVCEXT
+
+static int pvc_max_number = 16;	/* max number of PVCs */
+static int pvc_number = 0;	/* pvc unit number */
+
+struct ifnet *
+pvcsif_alloc()
+{
+	struct pvcsif *pvcsif;
+
+	if (pvc_number >= pvc_max_number)
+		return (NULL);
+	MALLOC(pvcsif, struct pvcsif *, sizeof(struct pvcsif),
+	       M_DEVBUF, M_WAITOK);
+	if (pvcsif == NULL)
+		return (NULL);
+	bzero(pvcsif, sizeof(struct pvcsif));
+
+#if defined(__NetBSD__) || defined (__OpenBSD__)
+	sprintf(pvcsif->sif_if.if_xname, "pvc%d", pvc_number++);
+#else
+	pvcsif->sif_if.if_name = "pvc";
+	pvcsif->sif_if.if_unit = pvc_number++;
+#endif
+	return (&pvcsif->sif_if);
+}
+
+/*
+ * pvc bridging support:
+ * add or delete brigding between 2 pvc interfaces.
+ */
+int
+pvc_set_fwd(if_name, if_name2, op)
+	char *if_name, *if_name2;
+	int op;		/* 0:delete 1:add 2:get */
+{
+	struct ifnet *ifp, *ifp2;
+	struct pvcsif *pvcsif, *pvcsif2;
+
+	if (strncmp(if_name, "pvc", 3) != 0
+	    || (ifp = ifunit(if_name)) == NULL)
+		return (EINVAL);
+	pvcsif = (struct pvcsif *)ifp;
+
+	if (op == 2) {
+		/* get bridging info */
+		if ((ifp2 = pvcsif->sif_fwdifp) == NULL)
+			*if_name2 = '\0';
+		else
+#if defined(__NetBSD__) || defined(__OpenBSD__)
+			sprintf(if_name2, "%s", ifp2->if_xname);
+#else
+			sprintf(if_name2, "%s%d",
+				ifp2->if_name, ifp2->if_unit);
+#endif
+		return (0);
+	}
+
+	if (strncmp(if_name2, "pvc", 3) != 0
+	    || (ifp2 = ifunit(if_name2)) == NULL)
+		return (EINVAL);
+	pvcsif2 = (struct pvcsif *)ifp2;
+
+	if (op) {
+		/* set up bridging */
+		pvcsif->sif_fwdifp = ifp2;
+		pvcsif2->sif_fwdifp = ifp;
+		ifp->if_flags |= IFF_LINK2;	/* use IFF_LINK2 to show */
+		ifp2->if_flags |= IFF_LINK2;	/* bridging is enabled   */
+	}
+	else {
+		/* delete bridging */
+		if (pvcsif->sif_fwdifp != ifp2 || pvcsif2->sif_fwdifp != ifp)
+			return (EINVAL);
+		pvcsif->sif_fwdifp = NULL;
+		pvcsif2->sif_fwdifp = NULL;
+		ifp->if_flags &= ~IFF_LINK2;
+		ifp2->if_flags &= ~IFF_LINK2;
+	}
+	return (0);
 }
+#endif /* ATM_PVCEXT */
diff -urN ../sys/net/if_bridge.c ./net/if_bridge.c
--- ../sys/net/if_bridge.c	Wed Apr  4 05:45:04 2001
+++ ./net/if_bridge.c	Thu Jun 21 18:31:05 2001
@@ -134,6 +134,14 @@
 int	bridge_brlconf __P((struct bridge_softc *, struct ifbrlconf *));
 u_int8_t bridge_filterrule __P((struct brl_head *, struct ether_header *));
 
+#ifdef ALTQ
+/*
+ * ALTQ support in ethernet bridging is only on the enqueue side.
+ */
+static int altq_etherclassify __P((struct ifaltq *, struct mbuf *,
+				   struct altq_pktattr *));
+#endif
+
 #define	ETHERADDR_IS_IP_MCAST(a) \
 	/* struct etheraddr *a;	*/				\
 	((a)->ether_addr_octet[0] == 0x01 &&			\
@@ -741,7 +749,11 @@
 	struct ifnet *dst_if;
 	struct ether_addr *src, *dst;
 	struct bridge_softc *sc;
-	int s;
+	int s, error, len;
+	short mflags;
+#ifdef ALTQ
+	struct altq_pktattr pktattr;
+#endif
 
 	if (m->m_len < sizeof(*eh)) {
 		m = m_pullup(m, sizeof(*eh));
@@ -779,6 +791,9 @@
 			dst_if = p->ifp;
 			if ((dst_if->if_flags & IFF_RUNNING) == 0)
 				continue;
+#ifdef ALTQ
+			if (!ALTQ_IS_ENABLED(&dst_if->if_snd))
+#endif
 			if (IF_QFULL(&dst_if->if_snd)) {
 				IF_DROP(&dst_if->if_snd);
 				sc->sc_if.if_oerrors++;
@@ -794,14 +809,25 @@
 					continue;
 				}
 			}
-
+			len = mc->m_pkthdr.len;
+			mflags = mc->m_flags;
+#ifdef ALTQ
+			if (ALTQ_IS_ENABLED(&dst_if->if_snd))
+				altq_etherclassify(&dst_if->if_snd, mc, &pktattr);
+			IFQ_ENQUEUE(&dst_if->if_snd, mc, &pktattr, error);
+#else
+			IFQ_ENQUEUE(&dst_if->if_snd, mc, error);
+#endif
+			if (error) {
+				sc->sc_if.if_oerrors++;
+				continue;
+			}
 			sc->sc_if.if_opackets++;
-			sc->sc_if.if_obytes += mc->m_pkthdr.len;
+			sc->sc_if.if_obytes += len;
 			dst_if->if_lastchange = time;
-			dst_if->if_obytes += mc->m_pkthdr.len;
-			IF_ENQUEUE(&dst_if->if_snd, mc);
-			if (mc->m_flags & M_MCAST)
-				ifp->if_omcasts++;
+			dst_if->if_obytes += len;
+			if (mflags & M_MCAST)
+				dst_if->if_omcasts++;
 			if ((dst_if->if_flags & IFF_OACTIVE) == 0)
 				(*dst_if->if_start)(dst_if);
 		}
@@ -817,19 +843,25 @@
 		splx(s);
 		return (0);
 	}
-	if (IF_QFULL(&dst_if->if_snd)) {
-		IF_DROP(&dst_if->if_snd);
+	len = m->m_pkthdr.len;
+	mflags = m->m_flags;
+#ifdef ALTQ
+	if (ALTQ_IS_ENABLED(&dst_if->if_snd))
+		altq_etherclassify(&dst_if->if_snd, m, &pktattr);
+	IFQ_ENQUEUE(&dst_if->if_snd, m, &pktattr, error);
+#else
+	IFQ_ENQUEUE(&dst_if->if_snd, m, error);
+#endif
+	if (error) {
 		sc->sc_if.if_oerrors++;
-		m_freem(m);
 		splx(s);
 		return (0);
 	}
 	sc->sc_if.if_opackets++;
-	sc->sc_if.if_obytes += m->m_pkthdr.len;
+	sc->sc_if.if_obytes += len;
 	dst_if->if_lastchange = time;
-	dst_if->if_obytes += m->m_pkthdr.len;
-	IF_ENQUEUE(&dst_if->if_snd, m);
-	if (m->m_flags & M_MCAST)
+	dst_if->if_obytes += len;
+	if (mflags & M_MCAST)
 		dst_if->if_omcasts++;
 	if ((dst_if->if_flags & IFF_OACTIVE) == 0)
 		(*dst_if->if_start)(dst_if);
@@ -877,11 +909,15 @@
 	struct bridge_softc *sc;
 	struct mbuf *m;
 {
-	int s;
+	int s, error, len;
 	struct ifnet *src_if, *dst_if;
 	struct bridge_iflist *ifl;
 	struct ether_addr *dst, *src;
 	struct ether_header eh;
+	short mflags;
+#ifdef ALTQ
+	struct altq_pktattr pktattr;
+#endif
 
 	if ((sc->sc_if.if_flags & IFF_RUNNING) == 0) {
 		m_freem(m);
@@ -1046,20 +1082,28 @@
 		m_freem(m);
 		return;
 	}
+#ifdef ALTQ
+	if (ALTQ_IS_ENABLED(&dst_if->if_snd))
+		altq_etherclassify(&dst_if->if_snd, m, &pktattr);
+#endif
+	len = m->m_pkthdr.len;
+	mflags = m->m_flags;
 	s = splimp();
-	if (IF_QFULL(&dst_if->if_snd)) {
-		IF_DROP(&dst_if->if_snd);
+#ifdef ALTQ
+	IFQ_ENQUEUE(&dst_if->if_snd, m, &pktattr, error);
+#else
+	IFQ_ENQUEUE(&dst_if->if_snd, m, error);
+#endif
+	if (error) {
 		sc->sc_if.if_oerrors++;
-		m_freem(m);
 		splx(s);
 		return;
 	}
 	sc->sc_if.if_opackets++;
-	sc->sc_if.if_obytes += m->m_pkthdr.len;
+	sc->sc_if.if_obytes += len;
 	dst_if->if_lastchange = time;
-	dst_if->if_obytes += m->m_pkthdr.len;
-	IF_ENQUEUE(&dst_if->if_snd, m);
-	if (m->m_flags & M_MCAST)
+	dst_if->if_obytes += len;
+	if (mflags & M_MCAST)
 		dst_if->if_omcasts++;
 	if ((dst_if->if_flags & IFF_OACTIVE) == 0)
 		(*dst_if->if_start)(dst_if);
@@ -1225,7 +1269,11 @@
 	struct bridge_iflist *p;
 	struct mbuf *mc;
 	struct ifnet *dst_if;
-	int used = 0;
+	int error, len, used = 0;
+	short mflags;
+#ifdef ALTQ
+	struct altq_pktattr pktattr;
+#endif
 
 	LIST_FOREACH(p, &sc->sc_iflist, next) {
 		/*
@@ -1248,6 +1296,9 @@
 		if ((dst_if->if_flags & IFF_RUNNING) == 0)
 			continue;
 
+#ifdef ALTQ
+		if (!ALTQ_IS_ENABLED(&dst_if->if_snd))
+#endif
 		if (IF_QFULL(&dst_if->if_snd)) {
 			IF_DROP(&dst_if->if_snd);
 			sc->sc_if.if_oerrors++;
@@ -1275,12 +1326,24 @@
 			continue;
 		}
 
+		len = mc->m_pkthdr.len;
+		mflags = mc->m_flags;
+#ifdef ALTQ
+		if (ALTQ_IS_ENABLED(&dst_if->if_snd))
+			altq_etherclassify(&dst_if->if_snd, mc, &pktattr);
+		IFQ_ENQUEUE(&dst_if->if_snd, mc, &pktattr, error);
+#else
+		IFQ_ENQUEUE(&dst_if->if_snd, mc, error);
+#endif
+		if (error) {
+			sc->sc_if.if_oerrors++;
+			continue;
+		}
 		sc->sc_if.if_opackets++;
-		sc->sc_if.if_obytes += mc->m_pkthdr.len;
-		dst_if->if_obytes += m->m_pkthdr.len;
+		sc->sc_if.if_obytes += len;
+		dst_if->if_obytes += len;
 		dst_if->if_lastchange = time;
-		IF_ENQUEUE(&dst_if->if_snd, mc);
-		if (mc->m_flags & M_MCAST)
+		if (mflags & M_MCAST)
 			dst_if->if_omcasts++;
 		if ((dst_if->if_flags & IFF_OACTIVE) == 0)
 			(*dst_if->if_start)(dst_if);
@@ -1972,3 +2035,80 @@
 	return (NULL);
 }
 #endif
+
+#ifdef ALTQ
+/*
+ * find the size of ethernet header, and call classifier
+ */
+static int
+altq_etherclassify(ifq, m, pktattr)
+	struct ifaltq *ifq;
+	struct mbuf *m;
+	struct altq_pktattr *pktattr;
+{
+	struct ether_header *eh;
+	u_short	ether_type;
+	int	hlen, af, hdrsize;
+	caddr_t hdr;
+
+	hlen = sizeof(struct ether_header);
+	eh = mtod(m, struct ether_header *);
+
+	ether_type = ntohs(eh->ether_type);
+	if (ether_type < ETHERMTU) {
+		/* ick! LLC/SNAP */
+		struct llc *llc = (struct llc *)(eh + 1);
+		hlen += 8;
+
+		if (m->m_len < hlen ||
+		    llc->llc_dsap != LLC_SNAP_LSAP ||
+		    llc->llc_ssap != LLC_SNAP_LSAP ||
+		    llc->llc_control != LLC_UI)
+			goto bad;  /* not snap! */
+
+		ether_type = ntohs(llc->llc_un.type_snap.ether_type);
+	}
+
+	if (ether_type == ETHERTYPE_IP) {
+		af = AF_INET;
+		hdrsize = 20;  /* sizeof(struct ip) */
+#ifdef INET6
+	} else if (ether_type == ETHERTYPE_IPV6) {
+		af = AF_INET6;
+		hdrsize = 40;  /* sizeof(struct ip6_hdr) */
+#endif
+	} else
+		goto bad;
+
+	while (m->m_len <= hlen) {
+		hlen -= m->m_len;
+		m = m->m_next;
+	}
+	hdr = m->m_data + hlen;
+	if (m->m_len < hlen + hdrsize) {
+		/*
+		 * ip header is not in a single mbuf.  this should not
+		 * happen in the current code.
+		 * (todo: use m_pulldown in the future)
+		 */
+		goto bad;
+	}
+	m->m_data += hlen;
+	m->m_len -= hlen;
+	if (ALTQ_NEEDS_CLASSIFY(ifq))
+		pktattr->pattr_class =
+		    (*ifq->altq_classify)(ifq->altq_clfier, m, af);
+	m->m_data -= hlen;
+	m->m_len += hlen;
+
+	pktattr->pattr_af = af;
+	pktattr->pattr_hdr = hdr;
+	return (1);
+
+bad:
+	pktattr->pattr_class = NULL;
+	pktattr->pattr_hdr = NULL;
+	pktattr->pattr_af = AF_UNSPEC;
+	return (0);
+}
+#endif /* ALTQ */
diff -urN ../sys/net/if_ethersubr.c ./net/if_ethersubr.c
--- ../sys/net/if_ethersubr.c	Wed Apr  4 05:45:04 2001
+++ ./net/if_ethersubr.c	Thu Jun 21 17:56:49 2001
@@ -245,13 +245,17 @@
 	struct rtentry *rt0;
 {
 	u_int16_t etype;
-	int s, error = 0;
+	int s, len, error = 0;
  	u_char edst[6];
 	register struct mbuf *m = m0;
 	register struct rtentry *rt;
 	struct mbuf *mcopy = (struct mbuf *)0;
 	register struct ether_header *eh;
 	struct arpcom *ac = (struct arpcom *)ifp;
+	short mflags;
+#ifdef ALTQ
+	struct altq_pktattr pktattr;
+#endif
 
 	if ((ifp->if_flags & (IFF_UP|IFF_RUNNING)) != (IFF_UP|IFF_RUNNING))
 		senderr(ENETDOWN);
@@ -278,6 +282,13 @@
 			    time.tv_sec < rt->rt_rmx.rmx_expire)
 				senderr(rt == rt0 ? EHOSTDOWN : EHOSTUNREACH);
 	}
+#ifdef ALTQ
+	/*
+	 * if the queueing discipline needs packet classification,
+	 * do it before prepending link headers.
+	 */
+	IFQ_CLASSIFY(&ifp->if_snd, m, dst->sa_family, &pktattr);
+#endif
 	switch (dst->sa_family) {
 
 #ifdef INET
@@ -519,19 +530,25 @@
 	}
 #endif
 
+	mflags = m->m_flags;
+	len = m->m_pkthdr.len;
 	s = splimp();
 	/*
 	 * Queue message on interface, and start output if interface
 	 * not yet active.
 	 */
-	if (IF_QFULL(&ifp->if_snd)) {
-		IF_DROP(&ifp->if_snd);
+#ifdef ALTQ
+	IFQ_ENQUEUE(&ifp->if_snd, m, &pktattr, error);
+#else
+	IFQ_ENQUEUE(&ifp->if_snd, m, error);
+#endif
+	if (error) {
+		/* mbuf is already freed */
 		splx(s);
-		senderr(ENOBUFS);
+		return (error);
 	}
-	ifp->if_obytes += m->m_pkthdr.len;
-	IF_ENQUEUE(&ifp->if_snd, m);
-	if (m->m_flags & M_MCAST)
+	ifp->if_obytes += len + sizeof (struct ether_header);
+	if (mflags & M_MCAST)
 		ifp->if_omcasts++;
 	if ((ifp->if_flags & IFF_OACTIVE) == 0)
 		(*ifp->if_start)(ifp);
diff -urN ../sys/net/if_loop.c ./net/if_loop.c
--- ../sys/net/if_loop.c	Tue Feb  6 21:33:36 2001
+++ ./net/if_loop.c	Thu Jun 21 18:33:16 2001
@@ -145,6 +145,10 @@
 #define	LOMTU	(32768 +  MHLEN + MLEN)
 #endif
   
+#ifdef ALTQ
+static void lo_altqstart __P((struct ifnet *));
+#endif
+
 void
 loopattach(n)
 	int n;
@@ -168,6 +172,10 @@
 		ifp->if_type = IFT_LOOP;
 		ifp->if_hdrlen = sizeof(u_int32_t);
 		ifp->if_addrlen = 0;
+		IFQ_SET_READY(&ifp->if_snd);
+#ifdef ALTQ
+		ifp->if_start = lo_altqstart;
+#endif
 		if_attachhead(ifp);
 #if NBPFILTER > 0
 		bpfattach(&ifp->if_bpf, ifp, DLT_LOOP, sizeof(u_int32_t));
@@ -222,6 +230,37 @@
 
 	ifp->if_opackets++;
 	ifp->if_obytes += m->m_pkthdr.len;
+#ifdef ALTQ
+	/*
+	 * altq for loop is just for debugging.
+	 * only used when called for loop interface (not for
+	 * a simplex interface).
+	 */
+	if ((ALTQ_IS_ENABLED(&ifp->if_snd) || TBR_IS_ENABLED(&ifp->if_snd))
+	    && ifp->if_start == lo_altqstart) {
+		struct altq_pktattr pktattr;
+		int32_t *afp;
+	        int error;
+
+		/*
+		 * if the queueing discipline needs packet classification,
+		 * do it before prepending link headers.
+		 */
+		IFQ_CLASSIFY(&ifp->if_snd, m, dst->sa_family, &pktattr);
+
+		M_PREPEND(m, sizeof(int32_t), M_DONTWAIT);
+		if (m == 0)
+			return(ENOBUFS);
+		afp = mtod(m, int32_t *);
+		*afp = (int32_t)dst->sa_family;
+
+	        s = splimp();
+		IFQ_ENQUEUE(&ifp->if_snd, m, &pktattr, error);
+		(*ifp->if_start)(ifp);
+		splx(s);
+		return (error);
+	}
+#endif /* ALTQ */
 	switch (dst->sa_family) {
 
 #ifdef INET
@@ -280,6 +319,87 @@
 	splx(s);
 	return (0);
 }
+
+#ifdef ALTQ
+static void
+lo_altqstart(ifp)
+	struct ifnet *ifp;
+{
+	struct ifqueue *ifq;
+	struct mbuf *m;
+	int32_t af, *afp;
+	int s, isr;
+	
+	while (1) {
+		s = splimp();
+		IFQ_DEQUEUE(&ifp->if_snd, m);
+		splx(s);
+		if (m == NULL)
+			return;
+
+		afp = mtod(m, int32_t *);
+		af = *afp;
+		m_adj(m, sizeof(int32_t));
+
+		switch (af) {
+#ifdef INET
+		case AF_INET:
+			ifq = &ipintrq;
+			isr = NETISR_IP;
+			break;
+#endif
+#ifdef INET6
+		case AF_INET6:
+			m->m_flags |= M_LOOP;
+			ifq = &ip6intrq;
+			isr = NETISR_IPV6;
+			break;
+#endif
+#ifdef IPX
+		case AF_IPX:
+			ifq = &ipxintrq;
+			isr = NETISR_IPX;
+			break;
+#endif
+#ifdef NS
+		case AF_NS:
+			ifq = &nsintrq;
+			isr = NETISR_NS;
+			break;
+#endif
+#ifdef ISO
+		case AF_ISO:
+			ifq = &clnlintrq;
+			isr = NETISR_ISO;
+			break;
+#endif
+#ifdef NETATALK
+		case AF_APPLETALK:
+			ifq = &atintrq2;
+			isr = NETISR_ATALK;
+			break;
+#endif NETATALK
+		default:
+			printf("lo_altqstart: can't handle af%d\n", af);
+			m_freem(m);
+			return;
+		}
+
+		s = splimp();
+		if (IF_QFULL(ifq)) {
+			IF_DROP(ifq);
+			m_freem(m);
+			splx(s);
+			return;
+		}
+		IF_ENQUEUE(ifq, m);
+		schednetisr(isr);
+		ifp->if_ipackets++;
+		ifp->if_ibytes += m->m_pkthdr.len;
+		splx(s);
+	}
+}
+#endif /* ALTQ */
 
 /* ARGSUSED */
 void
diff -urN ../sys/net/if_ppp.c ./net/if_ppp.c
--- ../sys/net/if_ppp.c	Wed Mar 22 08:31:27 2000
+++ ./net/if_ppp.c	Thu Jun 21 17:56:49 2001
@@ -199,10 +199,11 @@
 	sc->sc_if.if_hdrlen = PPP_HDRLEN;
 	sc->sc_if.if_ioctl = pppsioctl;
 	sc->sc_if.if_output = pppoutput;
-	sc->sc_if.if_snd.ifq_maxlen = IFQ_MAXLEN;
+	IFQ_SET_MAXLEN(&sc->sc_if.if_snd, IFQ_MAXLEN);
 	sc->sc_inq.ifq_maxlen = IFQ_MAXLEN;
 	sc->sc_fastq.ifq_maxlen = IFQ_MAXLEN;
 	sc->sc_rawq.ifq_maxlen = IFQ_MAXLEN;
+	IFQ_SET_READY(&sc->sc_if.if_snd);
 	if_attach(&sc->sc_if);
 #if NBPFILTER > 0
 	bpfattach(&sc->sc_bpf, &sc->sc_if, DLT_PPP, PPP_HDRLEN);
@@ -639,6 +640,9 @@
     enum NPmode mode;
     int len;
     struct mbuf *m;
+#ifdef ALTQ
+    struct altq_pktattr pktattr;
+#endif
 
     if (sc->sc_devp == NULL || (ifp->if_flags & IFF_RUNNING) == 0
 	|| ((ifp->if_flags & IFF_UP) == 0 && dst->sa_family != AF_UNSPEC)) {
@@ -646,6 +650,9 @@
 	goto bad;
     }
 
+#ifdef ALTQ
+    IFQ_CLASSIFY(&ifp->if_snd, m0, dst->sa_family, &pktattr);
+#endif
     /*
      * Compute PPP header.
      */
@@ -762,16 +769,34 @@
 	m0->m_nextpkt = NULL;
 	sc->sc_npqtail = &m0->m_nextpkt;
     } else {
-	ifq = (m0->m_flags & M_HIGHPRI)? &sc->sc_fastq: &ifp->if_snd;
-	if (IF_QFULL(ifq) && dst->sa_family != AF_UNSPEC) {
-	    IF_DROP(ifq);
+	if ((m0->m_flags & M_HIGHPRI)
+#ifdef ALTQ
+	    && !ALTQ_IS_ENABLED(&sc->sc_if.if_snd)
+#endif
+	    ) {
+	    ifq = &sc->sc_fastq;
+	    if (IF_QFULL(ifq) && dst->sa_family != AF_UNSPEC) {
+		IF_DROP(ifq);
+		m_freem(m0);
+		error = ENOBUFS;
+	    }
+	    else {
+		IF_ENQUEUE(ifq, m0);
+		error = 0;
+	    }
+	} else {
+#ifdef ALTQ
+	    IFQ_ENQUEUE(&sc->sc_if.if_snd, m0, &pktattr, error);
+#else
+	    IFQ_ENQUEUE(&sc->sc_if.if_snd, m0, error);
+#endif
+	}
+	if (error) {
 	    splx(s);
 	    sc->sc_if.if_oerrors++;
 	    sc->sc_stats.ppp_oerrors++;
-	    error = ENOBUFS;
-	    goto bad;
+	    return (error);
 	}
-	IF_ENQUEUE(ifq, m0);
 	(*sc->sc_start)(sc);
     }
     ifp->if_lastchange = time;
@@ -798,6 +823,7 @@
     struct mbuf *m, **mpp;
     struct ifqueue *ifq;
     enum NPmode mode;
+    int error;
 
     for (mpp = &sc->sc_npqueue; (m = *mpp) != NULL; ) {
 	switch (PPP_PROTOCOL(mtod(m, u_char *))) {
@@ -815,13 +841,32 @@
 	     */
 	    *mpp = m->m_nextpkt;
 	    m->m_nextpkt = NULL;
-	    ifq = (m->m_flags & M_HIGHPRI)? &sc->sc_fastq: &sc->sc_if.if_snd;
-	    if (IF_QFULL(ifq)) {
-		IF_DROP(ifq);
+	    if ((m->m_flags & M_HIGHPRI)
+#ifdef ALTQ
+		&& !ALTQ_IS_ENABLED(&sc->sc_if.if_snd)
+#endif
+		) {
+		ifq = &sc->sc_fastq;
+		if (IF_QFULL(ifq)) {
+		    IF_DROP(ifq);
+		    m_freem(m);
+		    error = ENOBUFS;
+		}
+		else {
+		    IF_ENQUEUE(ifq, m);
+		    error = 0;
+		}
+	    } else {
+#ifdef ALTQ
+		IFQ_ENQUEUE(&sc->sc_if.if_snd, m, NULL, error);
+#else
+		IFQ_ENQUEUE(&sc->sc_if.if_snd, m, error);
+#endif
+	    }
+	    if (error) {
 		sc->sc_if.if_oerrors++;
 		sc->sc_stats.ppp_oerrors++;
-	    } else
-		IF_ENQUEUE(ifq, m);
+	    }
 	    break;
 
 	case NPMODE_DROP:
@@ -873,7 +918,7 @@
      */
     IF_DEQUEUE(&sc->sc_fastq, m);
     if (m == NULL)
-	IF_DEQUEUE(&sc->sc_if.if_snd, m);
+	IFQ_DEQUEUE(&sc->sc_if.if_snd, m);
     if (m == NULL)
       return NULL;
 
@@ -999,7 +1044,7 @@
     s = splsoftnet();
     for (i = 0; i < NPPP; ++i, ++sc) {
 	if (!(sc->sc_flags & SC_TBUSY)
-	    && (sc->sc_if.if_snd.ifq_head || sc->sc_fastq.ifq_head)) {
+	    && (!IFQ_IS_EMPTY(&sc->sc_if.if_snd) || sc->sc_fastq.ifq_head)) {
 	    s2 = splimp();
 	    sc->sc_flags |= SC_TBUSY;
 	    splx(s2);
diff -urN ../sys/net/if_sl.c ./net/if_sl.c
--- ../sys/net/if_sl.c	Wed Mar 14 06:30:27 2001
+++ ./net/if_sl.c	Thu Jun 21 17:56:49 2001
@@ -214,8 +214,9 @@
 		sc->sc_if.if_type = IFT_SLIP;
 		sc->sc_if.if_ioctl = slioctl;
 		sc->sc_if.if_output = sloutput;
-		sc->sc_if.if_snd.ifq_maxlen = 50;
+		IFQ_SET_MAXLEN(&sc->sc_if.if_snd, 50);
 		sc->sc_fastq.ifq_maxlen = 32;
+		IFQ_SET_READY(&sc->sc_if.if_snd);
 		if_attach(&sc->sc_if);
 #if NBPFILTER > 0
 		bpfattach(&sc->sc_bpf, &sc->sc_if, DLT_SLIP, SLIP_HDRLEN);
@@ -380,8 +381,14 @@
 	register struct sl_softc *sc = ifp->if_softc;
 	register struct ip *ip;
 	register struct ifqueue *ifq;
-	int s;
+	int s, error;
+#ifdef ALTQ
+	struct altq_pktattr pktattr;
+#endif
 
+#ifdef ALTQ
+	IFQ_CLASSIFY(&ifp->if_snd, m, dst->sa_family, &pktattr);
+#endif
 	/*
 	 * `Cannot happen' (see slioctl).  Someday we will extend
 	 * the line protocol to support other address families.
@@ -403,14 +410,11 @@
 		m_freem(m);
 		return (EHOSTUNREACH);
 	}
-	ifq = &sc->sc_if.if_snd;
 	ip = mtod(m, struct ip *);
 	if (sc->sc_if.if_flags & SC_NOICMP && ip->ip_p == IPPROTO_ICMP) {
 		m_freem(m);
 		return (ENETRESET);		/* XXX ? */
 	}
-	if (ip->ip_tos & IPTOS_LOWDELAY)
-		ifq = &sc->sc_fastq;
 	s = splimp();
 	if (sc->sc_oqlen && sc->sc_ttyp->t_outq.c_cc == sc->sc_oqlen) {
 		struct timeval tv;
@@ -422,14 +426,33 @@
 			slstart(sc->sc_ttyp);
 		}
 	}
-	if (IF_QFULL(ifq)) {
-		IF_DROP(ifq);
-		m_freem(m);
+	if ((ip->ip_tos & IPTOS_LOWDELAY)
+#ifdef ALTQ
+	    && !ALTQ_IS_ENABLED(&sc->sc_if.if_snd)
+#endif
+		) {
+		ifq = &sc->sc_fastq;
+		if (IF_QFULL(ifq)) {
+			IF_DROP(ifq);
+			m_freem(m);
+			error = ENOBUFS;
+		} else {
+			IF_ENQUEUE(ifq, m);
+			error = 0;
+		}
+	} else {
+#ifdef ALTQ
+		IFQ_ENQUEUE(&sc->sc_if.if_snd, m, &pktattr, error);
+#else
+		IFQ_ENQUEUE(&sc->sc_if.if_snd, m, error);
+#endif
+	}
+	if (error) {
 		splx(s);
 		sc->sc_if.if_oerrors++;
-		return (ENOBUFS);
+		return (error);
 	}
-	IF_ENQUEUE(ifq, m);
+
 	sc->sc_if.if_lastchange = time;
 	if ((sc->sc_oqlen = sc->sc_ttyp->t_outq.c_cc) == 0)
 		slstart(sc->sc_ttyp);
@@ -496,7 +519,7 @@
 		if (m)
 			sc->sc_if.if_omcasts++;		/* XXX */
 		else
-			IF_DEQUEUE(&sc->sc_if.if_snd, m);
+			IFQ_DEQUEUE(&sc->sc_if.if_snd, m);
 		splx(s);
 		if (m == NULL)
 			return;
diff -urN ../sys/net/if_spppsubr.c ./net/if_spppsubr.c
--- ../sys/net/if_spppsubr.c	Wed Apr  4 05:45:04 2001
+++ ./net/if_spppsubr.c	Thu Jun 21 17:56:49 2001
@@ -639,8 +639,11 @@
 {
 	struct sppp *sp = (struct sppp*) ifp;
 	struct ppp_header *h;
-	struct ifqueue *ifq;
-	int s, rv = 0;
+	struct ifqueue *ifq = NULL;
+	int s, len, rv = 0;
+#ifdef ALTQ
+	struct altq_pktattr pktattr;
+#endif
 
 	s = splimp();
 
@@ -662,7 +665,13 @@
 		s = splimp();
 	}
 
-	ifq = &ifp->if_snd;
+#ifdef ALTQ
+	/*
+	 * if the queueing discipline needs packet classification,
+	 * do it before prepending link headers.
+	 */
+	IFQ_CLASSIFY(&ifp->if_snd, m, dst->sa_family, &pktattr);
+#endif
 #ifdef INET
 	/*
 	 * Put low delay, telnet, rlogin and ftp control packets
@@ -782,14 +791,33 @@
 	 * Queue message on interface, and start output if interface
 	 * not yet active.
 	 */
-	if (IF_QFULL (ifq)) {
-		IF_DROP (&ifp->if_snd);
-		m_freem (m);
+	len = m->m_pkthdr.len;
+	if (ifq != NULL
+#ifdef ALTQ
+	    && !ALTQ_IS_ENABLED(&ifp->if_snd)
+#endif
+		) {
+		if (IF_QFULL (ifq)) {
+			IF_DROP (&ifp->if_snd);
+			m_freem (m);
+			if (rv == 0)
+				rv = ENOBUFS;
+		}
+		IF_ENQUEUE (ifq, m);
+	}
+	else {
+#ifdef ALTQ
+		IFQ_ENQUEUE(&ifp->if_snd, m, &pktattr, rv);
+#else
+		IFQ_ENQUEUE(&ifp->if_snd, m, rv);
+#endif
+	}
+	if (rv != 0) {
 		++ifp->if_oerrors;
 		splx (s);
-		return (rv? rv: ENOBUFS);
+		return (rv);
 	}
-	IF_ENQUEUE (ifq, m);
+
 	if (! (ifp->if_flags & IFF_OACTIVE))
 		(*ifp->if_start) (ifp);
 
@@ -798,7 +826,7 @@
 	 * The packet length includes header, FCS and 1 flag,
 	 * according to RFC 1333.
 	 */
-	ifp->if_obytes += m->m_pkthdr.len + 3;
+	ifp->if_obytes += len + 3;
 	splx (s);
 	return (0);
 }
@@ -823,7 +851,7 @@
 
 	sp->pp_if.if_type = IFT_PPP;
 	sp->pp_if.if_output = sppp_output;
-	sp->pp_if.if_snd.ifq_maxlen = 50;
+	IFQ_SET_MAXLEN(&sp->pp_if.if_snd, 50);
 	sp->pp_fastq.ifq_maxlen = 50;
 	sp->pp_cpq.ifq_maxlen = 50;
 	sp->pp_loopcnt = 0;
@@ -870,7 +898,7 @@
 {
 	struct sppp *sp = (struct sppp*) ifp;
 
-	sppp_qflush (&sp->pp_if.if_snd);
+	IFQ_PURGE(&sp->pp_if.if_snd);
 	sppp_qflush (&sp->pp_fastq);
 	sppp_qflush (&sp->pp_cpq);
 }
@@ -886,7 +914,7 @@
 
 	s = splimp();
 	empty = !sp->pp_fastq.ifq_head && !sp->pp_cpq.ifq_head &&
-		!sp->pp_if.if_snd.ifq_head;
+		IFQ_IS_EMPTY(&sp->pp_if.if_snd);
 	splx(s);
 	return (empty);
 }
@@ -913,7 +941,7 @@
 	    (sppp_ncp_check(sp) || (sp->pp_flags & PP_CISCO) != 0)) {
 		IF_DEQUEUE(&sp->pp_fastq, m);
 		if (m == NULL)
-			IF_DEQUEUE (&sp->pp_if.if_snd, m);
+			IFQ_DEQUEUE (&sp->pp_if.if_snd, m);
 	}
 	splx(s);
 	return m;
@@ -936,7 +964,7 @@
 	    (sp->pp_phase == PHASE_NETWORK ||
 	     (sp->pp_flags & PP_CISCO) != 0))
 		if ((m = sp->pp_fastq.ifq_head) == NULL)
-			m = sp->pp_if.if_snd.ifq_head;
+			IFQ_POLL(&sp->pp_if.if_snd, m);
 	splx (s);
 	return (m);
 }
diff -urN ../sys/net/if_strip.c ./net/if_strip.c
--- ../sys/net/if_strip.c	Fri Jan 19 12:38:14 2001
+++ ./net/if_strip.c	Thu Jun 21 17:56:49 2001
@@ -362,11 +362,12 @@
 		sc->sc_if.if_type = IFT_SLIP;
 		sc->sc_if.if_ioctl = stripioctl;
 		sc->sc_if.if_output = stripoutput;
-		sc->sc_if.if_snd.ifq_maxlen = 50;
+		IFQ_SET_MAXLEN(&sc->sc_if.if_snd, 50);
 		sc->sc_fastq.ifq_maxlen = 32;
 
 		sc->sc_if.if_watchdog = strip_watchdog;
 		sc->sc_if.if_timer = STRIP_WATCHDOG_INTERVAL;
+		IFQ_SET_READY(&sc->sc_if.if_snd);
 		if_attach(&sc->sc_if);
 #if NBPFILTER > 0
 		bpfattach(&sc->sc_bpf, &sc->sc_if, DLT_SLIP, SLIP_HDRLEN);
@@ -715,7 +716,9 @@
 	register u_char *dldst;		/* link-level next-hop */
 	int s;
 	u_char dl_addrbuf[STARMODE_ADDR_LEN+1];
-
+#ifdef ALTQ
+	struct altq_pktattr pktattr;
+#endif
 
 	/*
 	 * Verify tty line is up and alive.
@@ -779,13 +782,17 @@
 		return (EAFNOSUPPORT);
 	}
 	
-	ifq = &sc->sc_if.if_snd;
+	ifq = NULL;
 	ip = mtod(m, struct ip *);
 	if (sc->sc_if.if_flags & SC_NOICMP && ip->ip_p == IPPROTO_ICMP) {
 		m_freem(m);
 		return (ENETRESET);		/* XXX ? */
 	}
-	if (ip->ip_tos & IPTOS_LOWDELAY)
+	if ((ip->ip_tos & IPTOS_LOWDELAY)
+#ifdef ALTQ
+	    && !ALTQ_IS_ENABLED(&sc->sc_if.if_snd)
+#endif
+		)
 		ifq = &sc->sc_fastq;
 
 	/*
@@ -843,14 +850,27 @@
 			stripstart(sc->sc_ttyp);
 		}
 	}
-	if (IF_QFULL(ifq)) {
-		IF_DROP(ifq);
-		m_freem(m);
+	if (ifq != NULL) {
+		if (IF_QFULL(ifq)) {
+			IF_DROP(ifq);
+			m_freem(m);
+			error = ENOBUFS;
+		} else {
+			IF_ENQUEUE(ifq, m);
+			error = 0;
+		}
+	} else {
+#ifdef ALTQ
+		IFQ_ENQUEUE(&sc->sc_if.if_snd, m, &pktattr, error);
+#else
+		IFQ_ENQUEUE(&sc->sc_if.if_snd, m, error);
+#endif
+	}
+	if (error) {
 		splx(s);
 		sc->sc_if.if_oerrors++;
-		return (ENOBUFS);
+		return (error);
 	}
-	IF_ENQUEUE(ifq, m);
 	sc->sc_if.if_lastchange = time;
 	if ((sc->sc_oqlen = sc->sc_ttyp->t_outq.c_cc) == 0) {
 		stripstart(sc->sc_ttyp);
@@ -940,7 +960,7 @@
 		if (m)
 			sc->sc_if.if_omcasts++;		/* XXX */
 		else
-			IF_DEQUEUE(&sc->sc_if.if_snd, m);
+			IFQ_DEQUEUE(&sc->sc_if.if_snd, m);
 		splx(s);
 		if (m == NULL) {
 			return;
diff -urN ../sys/netinet/ip_input.c ./netinet/ip_input.c
--- ../sys/netinet/ip_input.c	Wed Apr  4 05:45:06 2001
+++ ./netinet/ip_input.c	Thu Jun 21 17:56:49 2001
@@ -366,6 +366,12 @@
 		goto bad;
 	}
 
+#ifdef ALTQ
+	if (altq_input != NULL && (*altq_input)(m, AF_INET) == 0)
+		/* packet is dropped by traffic conditioner */
+		return;
+#endif
+
 	/*
 	 * Convert fields to host representation.
 	 */
diff -urN ../sys/netinet6/ip6_input.c ./netinet6/ip6_input.c
--- ../sys/netinet6/ip6_input.c	Wed Apr  4 05:45:07 2001
+++ ./netinet6/ip6_input.c	Thu Jun 21 18:38:39 2001
@@ -277,6 +277,13 @@
 
 	ip6stat.ip6s_nxthist[ip6->ip6_nxt]++;
 
+#ifdef ALTQ
+	if (altq_input != NULL && (*altq_input)(m, AF_INET6) == 0) {
+		/* packet is dropped by traffic conditioner */
+		return;
+	}
+#endif
+
 	/*
 	 * Scope check
 	 */
